<?php
/**
 * @project wp-club
 * @file    wp_club_teams.php
 * @class   Team
 * @author  Alex Borras
 * @date    0505-0707-08080808
 * Class of table wp_club_teams
 */
class Team
{
/**
 * Class Team
*/
function Team($p_team_id = 0)
{
    $num_args = func_num_args();
	// ID value or recordset
    if ($num_args >0)
    {
    	$this->select($p_team_id);
    }
}
// Private Vars
private $team_id;
private $team_txt;
private $club_id;
private $category_id;
private $sortorder;
private $points;
private $exits;
private $standings;
private $col_matches = array();
private $col_players = array();
//**
//* Publics properties
//*
/**
* Return team_id
*
* @return bigint(20)
*/
function get_team_id()
{
	return $this->team_id;
}
/**
* Set team_id
*
* @return   void
*/
function set_team_id($p_team_id)
{
    $this->team_id=$p_team_id;
}
/**
* Return team_txt
*
* @return varchar(255)
*/
function get_team_txt()
{
	return $this->team_txt;
}
/**
* Set team_txt
*
* @return   void
*/
function set_team_txt($p_team_txt)
{
    $this->team_txt=$p_team_txt;
}
/**
* Return club_id
*
* @return bigint(20)
*/
function get_club_id()
{
	return $this->club_id;
}
/**
* Set club_id
*
* @return   void
*/
function set_club_id($p_club_id)
{
    $this->club_id=$p_club_id;
}
/**
* Return category_id
*
* @return bigint(20)
*/
function get_category_id()
{
	return $this->category_id;
}
/**
* Set category_id
*
* @return   void
*/
function set_category_id($p_category_id)
{
    $this->category_id=$p_category_id;
}
/**
* Return sortorder
*
* @return bigint(20)
*/
function get_sortorder()
{
	return $this->sortorder;
}
/**
* Set sortorder
*
* @return   void
*/
function set_sortorder($p_sortorder)
{
    $this->sortorder=$p_sortorder;
}
/**
* Return existe
*
* @return boolean
*/
function get_existe()
{
	return $this->existe;
}
/**
* Set existe
*
* @return   void
*/
function set_existe($p_existe)
{
    $this->existe=$p_existe;
}
//**
//* Publics Methods
//*
function select($p_team_id)
{
    // Se est pasando un recordset
	if (is_object($p_team_id) )
	{
		$this->fill_properties($p_team_id);
		return;
	}
	// Tratamiento de Acceso para cdigo numricos
	$sql = "SELECT * FROM wp_club_teams ";
	if (is_numeric($p_team_id) ) // Se est pasando el identificador
	{
		$sql.= "WHERE team_id=".$p_team_id;
	}
   global $wpdb;
   $this->exits = false;
   $rst = $wpdb->get_results($sql);
   if ( $rst ) {
      foreach( $rst as $row ) {
		   $this->exits = true;
	       $this->fill_properties($row);
      }
   }
}
function fill_properties($p_row)
	// Fill class properties
{
    $this->team_id = $p_row->team_id;
    $this->team_txt = $p_row->team_txt;
    $this->club_id = $p_row->club_id;
    $this->category_id = $p_row->category_id;
    $this->sortorder = $p_row->sortorder;
    //echo "<br>zzz".$p_row->team_id.":".$p_row->team_txt;
}
/**
* Method 
*
* @return   void
*/
function addnew()
	// Insert new data
{
    $sql = "INSERT INTO wp_club_teams SET ";
    $sql.= $this->fill_sql_properties();
    global $wpdb;
    $wpdb->query($sql);
}
/**
* Method 
*
* @return   void
*/
function update()
{
	// Modify data, properties must be filled
	$sql = "UPDATE wp_club_teams SET ";
	$sql.= $this->fill_sql_properties();
    $sql.= " WHERE team_id=". $this->team_id ." LIMIT 1;";
    global $wpdb;
    $wpdb->query($sql);
}
/**
* Method 
*
* @return   void
*/
function delete()
{
    // Delete data
	$sql = "DELETE FROM wp_club_teams ";
    $sql.= " WHERE team_id=". $this->team_id ." LIMIT 1;";
    global $wpdb;
    $wpdb->query($sql);
}
/**
 * Fille properties for SQL query Insert and Update
 *
 * @return   string
*/
function fill_sql_properties()
{
       $sql.= "team_txt='".$this->team_txt."',";
       $sql.= "club_id='".$this->club_id."',";
       $sql.= "category_id='".$this->category_id."',";
       $sql.= "sortorder='".$this->sortorder."',";
    $sql = substr($sql, 0, -1)." "; // del last quote
    return $sql;
}
/**
* Return Tab of data Class
*
@return   string
*/
function show($p_view = "estandar")
{
	switch ($p_view)
	{
		case "estandar":
			return $str;
			break;
	}
}
/**
 * object Scores, frriendly class of Teams
 * @return Array
 */
function get_scores($p_competition)
{
    global $wpdb;
	$col = array();
	$sql = "SELECT * FROM wp_club_scores WHERE competition_id='$p_competition' AND team_id='".$this->get_team_id()."'";
	//echo "Sentencia SQL:<br>$sql";
	$rst = $wpdb->get_results($sql);
	if ( is_array($rst) ) {
	    foreach( $rst as $row ) {
			$col['points'] = $row->points;
			$col['games_played'] = $row->games_played;
			$col['games_won'] = $row->games_won;
			$col['games_drawn'] = $row->games_drawn;
			$col['games_lost'] = $row->games_lost;
			$col['goals_for'] = $row->goals_for;
			$col['goals_against'] = $row->goals_against;		
		    return $col;
	    	} 
	    } else {
	    $col['points'] = 0;
	}
	return $col;
}
//End Class
// And Manually
/**
 * Return Team games of Competition
 * @return array
 */
function get_matches($p_competition_id)
{
    $this->col_matches = get_col_matches($p_competition_id, $this->get_team_id());
    return $this->col_matches;
}
/**
 * Return Team games of Competition
 * @return array
 */
function get_players($p_season_id = 0)
{
    $this->col_players = get_col_players($this->team_id);
    return $this->col_players;
}
}
?>
