<?php
/**
 * @author   Alex Borrs <alex@alexborras.com>
 */
	include_once("club-class-team.php");
	include_once("club-class-player.php");
	include_once("club-class-competition.php");
	//include_once("club-class-coach_types.php");
/**
 * Return Teams Colecction
 *
 * @param bigint $p_club_id
 * @param text $p_team_txt
 * @param text $p_order_by
 * @param integer $p_reg_ini
 * @param integer $p_reg_pag
 * @return Team
 */
function get_col_teams($p_club_id = 0, $p_team_txt = "%",$p_order_by = "sortorder", $p_reg_ini = 0,$p_reg_pag = 0)
{
	global $wpdb;
	if ($p_team_txt == ""){
		$p_team_txt = "%";
	}
	if ($p_order_by == ""){
		$p_order_by = "sortorder";
	}
	$col = array();
	$sql = "SELECT * FROM {$wpdb->prefix}club_teams ";
	$sql.= "WHERE team_txt LIKE '%$p_team_txt%' ";
	// make WHERE section with other parameters
	if ($p_club_id <> 0)
	{
		$sql.= "club_id = $p_club_id";
	}
	// make ORDER BY
	$sql.= " ORDER BY $p_order_by ";
	// Construir LIMIT
	if ($p_reg_ini > 0 OR $p_reg_pag > 0)
	{
	    $sql.= " LIMIT $p_reg_ini, $p_reg_pag; ";
	}
	//echo "SQL:<br>$sql";
	$rst = $wpdb->get_results($sql);
	if ( is_array($rst) ) {
		foreach ( $rst as $row ) {
			$obj = new Team($row);
			$col[] = $obj;
			unset($obj);
		}
	}
	return $col;
}

/**
 * Return Teams Colecction in Competition
 *
 * @param bigint $p_competition_id
 */
function get_col_competition_teams($p_competition_id)
{
	global $wpdb;
	$col = array();
	$sql = "SELECT * FROM {$wpdb->prefix}club_scores ";
	$sql.= "WHERE competition_id='$p_competition_id' ";
	$sql.= " ORDER BY sortorder ";
	//echo "SQL:<br>$sql";
	$rst = $wpdb->get_results($sql);
	if ( is_array($rst) ) {
		foreach ( $rst as $row ) {
			$obj = new Team($row->team_id);
			$col[] = $obj;
			unset($obj);
		}
	}
	return $col;
}
/**
 * Return Teams Colecction in Competition
 *
 * @param bigint $p_competition_id
 */
function get_col_competition_gameweeks($p_competition_id)
{
	global $wpdb;
	$col = array();	
	$sql = "SELECT competition_id, gameweek FROM {$wpdb->prefix}club_matches ";
	$sql.= " GROUP BY competition_id, gameweek ";
	$sql.= " HAVING competition_id='$p_competition_id' ORDER BY gameweek ";
	//echo "SQL:<br>$sql";
	$rst = $wpdb->get_results($sql);
	if ( is_array($rst) ) {
		foreach ( $rst as $row ) {
			$obj = new Gameweek($row->competition_id, $row->gameweek);
			$col[] = $obj;
			unset($obj);
		}
	}
	return $col;
}
/**
 * Return Team Games Colecction in Competition
 *
 * @param bigint $p_competition_id
 */
function get_col_matches($p_competition_id,$p_team_id)
{
	global $wpdb;
	$col = array();
	$sql = "SELECT match_id FROM {$wpdb->prefix}club_matches ";
	$sql.= "WHERE competition_id='$p_competition_id' AND (team_home_id='$p_team_id' OR team_away_id='$p_team_id') ";
	$sql.= " ORDER BY gameweek ";
	//echo "SQL:<br>$sql";
	$rst = $wpdb->get_results($sql);
	if ( is_array($rst) ) {
		foreach ( $rst as $row ) {
			$obj = new Match($row->match_id);
			$col[] = $obj;
			unset($obj);
		}
	}
	return $col;
}
/**
 * Return Team Games Colecction in Competition by GameWeek
 *
 * @param bigint $p_competition_id
 */
function get_col_matches_gameweek($p_competition_id,$p_gameweek)
{
	global $wpdb;
	$col = array();
	$sql = "SELECT match_id FROM {$wpdb->prefix}club_matches ";
	$sql.= " WHERE competition_id='$p_competition_id' AND gameweek='$p_gameweek' ";
	$sql.= " ORDER BY gameweek, match_date ";
	//echo "SQL:<br>$sql";
	$rst = $wpdb->get_results($sql);
	if ( is_array($rst) ) {
		foreach ( $rst as $row ) {
			$obj = new Match($row->match_id);
			$col[] = $obj;
			unset($obj);
		}
	}
	return $col;
}
/**
 * Return Players Colecction
 *
 * @param bigint $p_team_id
 * @param text $p_player_txt
 * @param text $p_order_by
 * @param integer $p_reg_ini
 * @param integer $p_reg_pag
 * @return Player
 */
function get_col_players($p_team_id = 0, $p_player_txt = "%",$p_order_by = "number", $p_reg_ini = 0,$p_reg_pag = 0)
{
	global $wpdb;
	if ($p_team_txt == ""){
		$p_team_txt = "%";
	}
	if ($p_order_by == ""){
		$p_order_by = "sortorder";
	}
	$col = array();
	$sql = "SELECT * FROM {$wpdb->prefix}club_players ";
	$sql.= "WHERE player_txt LIKE '%$p_player_txt%' ";
	// make WHERE section with other parameters
	if ($p_team_id <> 0)
	{
		$sql.= " AND team_id = $p_team_id";
	}
	// make ORDER BY
	$sql.= " ORDER BY $p_order_by ";
	// Construir LIMIT
	if ($p_reg_ini > 0 OR $p_reg_pag > 0)
	{
	    $sql.= " LIMIT $p_reg_ini, $p_reg_pag; ";
	}
	//echo "SQL:<br>$sql";
	$rst = $wpdb->get_results($sql);
	if ( is_array($rst) ) {
		foreach ( $rst as $row ) {
			$obj = new Player($row);
			$col[] = $obj;
			unset($obj);
		}
	}
	return $col;
}
/**
 * Return Players with Sanction Colecction
 *
 * @param text $p_order_by
 * @param integer $p_reg_ini
 * @param integer $p_reg_pag
 * @return Player
 */
function get_col_players_sanctions($p_order_by = "player_txt", $p_reg_ini = 0,$p_reg_pag = 0){
	global $wpdb;
	if ($p_team_txt == ""){
		$p_team_txt = "%";
	}
	if ($p_order_by == ""){
		$p_order_by = "sortorder";
	}
	$col = array();
	$sql = "SELECT * FROM {$wpdb->prefix}club_players ";
	$sql.= "WHERE matches_remaining >0 ";	
	// make ORDER BY
	$sql.= " ORDER BY $p_order_by ";
	// Construir LIMIT
	if ($p_reg_ini > 0 OR $p_reg_pag > 0)
	{
	    $sql.= " LIMIT $p_reg_ini, $p_reg_pag; ";
	}
	//echo "SQL:<br>$sql";
	$rst = $wpdb->get_results($sql);
	if ( is_array($rst) ) {
		foreach ( $rst as $row ) {
			$obj = new Player($row);
			$col[] = $obj;
			unset($obj);
		}
	}
	return $col;
}
/**
 * Return Competitions Colecction
 *
 * @param bigint $p_club_id
 * @param text $p_team_txt
 * @param text $p_order_by
 * @param integer $p_reg_ini
 * @param integer $p_reg_pag
 * @return Team
 */
function get_col_competitions($p_season_id = 0)
{
	global $wpdb;
	if ($p_team_txt == ""){
		$p_team_txt = "%";
	}
	if ($p_order_by == ""){
		$p_order_by = "sortorder";
	}
	$col = array();
	$sql = "SELECT * FROM {$wpdb->prefix}club_competitions ";
	if ($p_season_id > 0) {
		$sql.= "WHERE $p_season_id = '%$p_season_id%' ";
	}
	// make WHERE section with other parameters
	// make ORDER BY
	$sql.= " ORDER BY $p_order_by ";
	// Construir LIMIT
	if ($p_reg_ini > 0 OR $p_reg_pag > 0)
	{
	    $sql.= " LIMIT $p_reg_ini, $p_reg_pag; ";
	}
	//echo "SQL:<br>$sql";
	$rst = $wpdb->get_results($sql);
	if ( is_array($rst) ) {
		foreach ( $rst as $row ) {
			$obj = new Competition($row);
			$col[] = $obj;
			unset($obj);
		}
	}
	return $col;
}
function club_tag($p_content,$p_tag_prefixe,$p_tag_end = "]"){
	$return = array();
	$return['fulltag'] = false;
	$return['codetag'] = false;
	$findcode = false;
	$pos = strpos($p_content,$p_tag_prefixe);
	if ($pos === false){
		return false;
	}
	for ($i = $pos ; $i <= strlen($p_content); $i++){
		$char = substr($p_content,$i,1);
		$return['fulltag'].= $char;
		if ($char == $p_tag_end){	
			break;
		}
		if ($findcode){
			$return['codetag'].=$char;
		}
		if ($char == "="){
			$findcode = true;
		}		
	}
	return $return;
}
function url_base() {
	$url = explode("&",$_SERVER['REQUEST_URI']);
	return $url[0];
}
function file_name($p_file)
{
	$file = explode(".",$p_file);
	// Usas un for por si el nombre del archivo tiene puntos 
	// y no recorres la ultima posicion que se supone tiene la
	// extension del archivos
	for ($i = 0 ; $i < count($file)-1 ; $i++)
	{
	        $name.= $file[$i].".";
	}
	// Eliminar el ultimo punto
	$name = substr($name,0,-1);
	// imprimes el nombre o haces con el lo que quieras :)
	return $name;
}
function file_shortname($p_file)
{
	$temp = explode("/",$p_file);
	$temp2 = count($temp) - 1;
	return  $temp[$temp2];	
}
function file_extension($p_file)
{
	$temp = explode(".",$p_file);
	$temp2 = count($temp) - 1;
	return  $temp[$temp2];	
}
/**
 * Date Functions
 *
 * @param unknown_type $p_month
 * @return unknown
 */
function select_month($p_month = 1){
    $months = array();
    $months[1] = "enero";
    $months[2] = "febrero";
    $months[3] = "marzo";
    $months[4] = "abril";
    $months[5] = "mayo";
    $months[6] = "junio";
    $months[7] = "julio";
    $months[8] = "agosto";
    $months[9] = "septiembre";
    $months[10] = "octubre";
    $months[11] = "noviembre";
    $months[12] = "diciembre";
	$str  = "<select name =\"month\">\n";
	for ( $i = 1; $i <= 12; $i++ ){
		$str .= "<option value=\"$i\"";
		if ($i == intval($p_month)){
			$str .="' selected>" ;
		}else{
		  	$str .="'>" ;
		}
		$str.= $months[$i]."</option>\n";
	}
	$str .= "</select>\n";
	return $str;
}
/**
 * Returns date with for write in SQL Syntax
 * @param  $p_date len  1 = Today
 *                     10 = Format: dd-mm-yyyy o yyyy-mm-dd
 */
function date_sql($p_date=0){
    // len date
    switch (strlen($p_date)){
        case 1 : // Today
            $date = date("Y-m-d");
            return $date;
            break;
        case 10: // format: dd-mm-yyyy o yyyy-mm-dd
            if (is_numeric(substr($p_date,6,4))==true){ // Year its last
                $day   = substr($p_date,0,2);
                $month = substr($p_date,3,2);
                $year  = substr($p_date,6,4);
            } else {
                $day   = substr($p_date,8,2);
                $month = substr($p_date,5,2);
                $year  = substr($p_date,0,4);
            }
            break;
        default:
            echo "<br>Exit by default, len: ".strlen($p_date);

    }
    $date = "$year-$month-$day";
    if (checkdate($month,$day,$year)==true){
        return $date;
    }else{
        print "<br>Error,this string: |$date| is not a date, original param: $p_date";
    }
}
?>